## mingw-w64-precice-2.5.0-6.src.tar.zst

=== thirdparty/fmt/CMakeLists.txt ===
add_library(fmt-header-only INTERFACE IMPORTED GLOBAL)
set_target_properties(fmt-header-only
  PROPERTIES
  INTERFACE_INCLUDE_DIRECTORIES "${CMAKE_CURRENT_LIST_DIR}/include"
  INTERFACE_COMPILE_DEFINITIONS FMT_HEADER_ONLY=1)
