=== thirdparty/json/CMakeLists.txt ===
add_library(JSON INTERFACE IMPORTED GLOBAL)
set_property(TARGET JSON PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${CMAKE_CURRENT_LIST_DIR}/include")
